' --------------------------------------------------------------------------------------------------
' evi_d31.bas ist ein Basic-Script das in Verbindung mit dem Serial Scriptable Port (elviscpd)' des Visualisierungssystems Elvis eingesetzt werden kann.
' Es implementiert die Steuerrung eines Sony EVI D31.
'
' Die Parameter fr die Schnittstelle knnen ber die Projektierung angegeben werden. Das Trennzeichen ist der "/".
' Beispiel: OpenParam=port=COM5/baud=19200/parity=n/data=8/Stop=1/xon=off/rts=off
'
' Historie:
' Harald Pokorny: Kopf(globale Variablen;OnOpen;Main;OnClose;GetTokenValue;FillPortSettings;SendBytes;SendValue;OnReceive;ShiftAccuLeft)
' 03.05.2006, Holger Schnauer: Erstellung unter Verwendung des Kopfes (s.oben)
' 05.05.2006, Harald Pokorny & Holger Schnauer: Erweiterung (Funktion: MergeValue_SvrInfo)
' 08.05.2006, Holger Schnauer: Test
' 09.05.2006, Holger Schnauer: Erweiterung (Funktion: MergeValue_SvrInfo, FillHex)
'
' Copyright (C) 2005, IT GmbH
' --------------------------------------------------------------------------------------------------
' Dieses Makro ist Teil des Softwareprodukts Elvis. Es kann frei verwendet,
' modifiziert und verteilt werden, vorausgesetzt, obige Copyright-Notiz wird nicht entfernt.
' Ein Gewhrleistung fr die korrekte Funktion des Makros wird nicht bernommen.
' --------------------------------------------------------------------------------------------------

Option Explicit
Option Base 0

Global g_A(1023) As Integer 				'Accumulator as Byte Array, length =  max 4 x 255
Global g_AWI As Integer					'write index
Global g_MsgType As Integer				'typ of message - any of the types defined
Global g_sLastMsgSend As String

Global g_time_last_receive As Single		'Time of last receive data

Public vHor As Integer				'Wert fr die Horizontale Position
Public vVer As Integer 		 		'Wert fr die Vertikale Position
Public panspeed As Integer			'Wert fr die Drehgeschwindigkeit
Public tiltspeed As Integer			'Wert fr die Schwenkgeschwindigkeit
Sub Main()
   	'OnOpen
   	'OnClose
End Sub


Sub OnOpen(sParam As String)
	Dim sPortSettings() As String			' parameter of open = port settings (array)
	Dim sPortComSettings As String

    Print "Start OnOpen ------------------------------ version 0.1.1"
    FillPortSettings sPortSettings, sParam, "/"
    Print "Parameter: " & sParam
	'2. parameter of OpenCommPort is mode:
	'baud=<Baudrate>
	'parity=n|e|o|m|s
	'data=5|6|7|8
	'stop=1|1,5|2
	'to=on|off
	'xon=on|off
	'odsr=on|off
	'octs=on|off
	'dtr=on|off|hs
	'rts=on|off|hs|tg
	'idsr=on|off
    
	'OpenCommPort "COM5", "Baud=19200, parity=n, data=8, stop=1, xon=off, rts=off"
	
	sPortComSettings = GetTokenValue(sPortSettings, "baud=", "baud=", "9600")
	sPortComSettings = sPortComSettings & "," & GetTokenValue(sPortSettings, "parity=", "parity=" ,"n")
	sPortComSettings = sPortComSettings & "," & GetTokenValue(sPortSettings, "data=", "data=", "8")
	sPortComSettings = sPortComSettings & "," & GetTokenValue(sPortSettings, "stop=", "stop=", "1")
	sPortComSettings = sPortComSettings & "," & GetTokenValue(sPortSettings, "xon=", "xon=", "off")
	sPortComSettings = sPortComSettings & "," & GetTokenValue(sPortSettings, "rts=", "rts=", "off")	
	
	'Print "sPortComSettings: " & sPortComSettings
	
	OpenCommPort GetTokenValue(sPortSettings, "port=", "", "COM1"), sPortComSettings
	g_AWI = 0
End Sub

Sub OnClose()
    CloseCommPort	'will be closed automatic if this is not done here
End Sub

Function GetTokenValue(sPortSettings() As String, ByVal sToken As String, sPreText As String, sDefault As String) As String
        Dim sPortSetting As String
        Dim nLenToken As Integer
        
        GetTokenValue = sPreText & sDefault
        
        nLenToken = Len(sToken ) 
        'Print "GetTokenValue sPortSettings(1) = " & sPortSettings(1)
        'Print "GetTokenValue sPortSettings(2) = " & sPortSettings(2)
        'Print "GetTokenValue sPortSettings(3) = " & sPortSettings(3)
        'Print "GetTokenValue sPortSettings(4) = " & sPortSettings(4)
        Dim i As Integer
        For i = UBound(sPortSettings) To 1 Step -1
                sPortSetting = sPortSettings(i)
                'Print "sToken = " & sToken
                'Print "Left(sPortSetting, nLenToken) = " & Left(sPortSetting, nLenToken)
                If Left(sPortSetting, nLenToken) = LCase(sToken) Then
                        'Print "GetTokenValue = " & Right(sPortSetting, Len(sPortSetting)-nLenToken)
                        GetTokenValue = sPreText & Right(sPortSetting, Len(sPortSetting) - nLenToken)
                        Exit For
                End If
        Next i
End Function


Sub FillPortSettings(sPortSettings() As String, sInput As String, sep As String)

	Dim nPortSettings As Integer			' Argumente - Zhler
	Dim sPortSetting As String
	Dim iPos As Integer
	Dim sRest As String
	
	If Len(sInput) < 1 Then GoTo ExitFunction
	nPortSettings = 1
	ReDim Preserve sPortSettings(nPortSettings)

	sRest = sInput
	'Print "sRest = " & sRest
                
	iPos = InStr(sRest, sep)
	While iPos > 0
		sPortSetting = Left(sRest, iPos - 1)
		'Print "sPortSetting = " & sPortSetting
		If sPortSetting <> "" Then
			ReDim Preserve sPortSettings(nPortSettings)
			sPortSettings(nPortSettings) = sPortSetting
			nPortSettings = nPortSettings + 1
			'Print "sPortSettings(" & CStr(nPortSettings) & ") = " & sPortSetting
		End If
		sRest = Right(sRest, Len(sRest) - iPos)
		iPos = InStr(sRest, sep)
	Wend
	ReDim Preserve sPortSettings(nPortSettings)
	sPortSettings(nPortSettings) = sRest


ExitFunction:

End Sub

Function MergeValue_SvrInfo(v As Variant, svrinfo As String) As String
	Dim sLeft As String					 
	Dim sRight As String
	Dim nPosBracketOpen As Integer
	Dim nPosBracketClose As Integer
	Dim sReplacement As String
	Dim sValue  As String
	Dim sValueZ As String 					'modifizierter Wert fr den Zoom
	Dim sValueH As String					'modifizierter Wert fr die Horizontale Position
	Dim sValueV As String					'modifizierter Wert fr die Vertikale Position
	Dim sValueP As String					'modifizierter Wert fr die Drehgeschwindigkeit
	Dim sValueT As String					'modifizierter Wert fr die Schwenkgeschwindigkeit

	
'untersucht die svrinfo nach mglichen Optionen (z.B. vert...)
	Select Case Left(svrinfo,4)
	Case "vert" 
		
		vVer = v 								'speichert den Wert fr die 
												'vertikale Bewegung der Kamera
		sLeft = Mid(svrinfo, 5, 4) 			'entnimmt sLeft zur spteren Verwendung

	Case "hori"

		vHor = v 								'speichert den Wert fr die 
												'horizontale Bewegung der Kamera
		sLeft = Mid(svrinfo, 5, 4) 			'entnimmt sLeft zur spteren Verwendung
	
	Case "zoom" 		

		sValueZ = v  							'speichert den Wert fr den Zoom
		sLeft = Mid(svrinfo, 5, 4)			'entnimmt sLeft zur spteren Verwendung							

	Case "pans" 		
	
		panspeed = v 							'speichert den Wert fr die horizontale Geschwindigkeit	
		sLeft = Mid(svrinfo,5 , 4)			'entnimmt sLeft zur spteren Verwendung							
	
	Case "tilt" 
	
		tiltspeed = v							'speichert den Wert fr die vertikale Geschwindigkeit
		sLeft = Mid(svrinfo,5 , 4)			'entnimmt sLeft zur spteren Verwendung							
	
	Case "ispd"								'fr die direkten Steuertasten
	 		 
		sLeft = Mid(svrinfo, 5, 4)  		'entnimmt sLeft zur spteren Verwendung							
	
	Case Else
	
		MergeValue_SvrInfo = svrinfo		'keine Option gefunden.svrinfo wird als Ganzes behandelt
		Exit Function
	
	End Select 		

	nPosBracketOpen = InStr(svrinfo, "[")		
	nPosBracketClose = InStr(svrinfo, "]")	
	
	If nPosBracketOpen > 0 And nPosBracketClose > nPosBracketOpen Then
		sRight = Right(svrinfo, Len(svrinfo) - nPosBracketClose)
		sReplacement = Mid(svrinfo, nPosBracketOpen, nPosBracketClose - nPosBracketOpen + 1)
		Select Case sReplacement
			Case "[2hex]"								'wenn in der svrinfo [2hex] vorkommt
	
				sValueP = FillHex(panspeed,2)		'wird verwendet fr die Einstellung der Geschwindigkeit
				sValueT = FillHex(tiltspeed,2)
				
				MergeValue_SvrInfo = sLeft & sValueP & sValueT & sRight
				
			Case "[4hex]"								'wenn in der svrinfo [2hex] vorkommt
	
				sValueZ = FillHex(v,4)	   			'wird fr den Zoom verwendet 
				MergeValue_SvrInfo = sLeft & sValueZ & sRight
			
			Case "[10hex]"							'wenn in der svrinfo [10hex] vorkommt 
					
				sValueH = FillHex(vHor,4)			'die Horizontale Position wird festgelegt
				sValueV = FillHex(vVer,4)			'die Vertikale Position wird festgelegt
				sValueP = FillHex(panspeed,2)		'die Horizontale Geschwingigkeit wird festgelegt
				sValueT = FillHex(tiltspeed,2)		'die Vertikale Geschwindigkeit wird festgelegt
 				MergeValue_SvrInfo = sLeft & sValueP & sValueT & sValueH & sValueV & sRight	'alles wird zusammengestellt
 	
 			Case Else

				sValue = ""			
				MergeValue_SvrInfo = sLeft & sValue

		End Select
		
	End If
End Function

Function FillHex(ByVal v As Variant, ByVal nhex As Integer) As String  
				Dim sValHex As String
				Dim i As Integer
				Dim sValue As String
				sValHex = Hex(CInt(v))   				'v wird in einen hexadezimalen Wert umgewandelt
				If Left(v,1) <> "-" Then					'unterscheidet,ob v negativ/positiv
									
						While Len(sValHex) < nhex		'Sollte sie Lnge des Strings sValHex nicht gleich 4 sein,wird 
							sValHex = "0" & sValHex		'er solange mit 0 aufgefllt bis die Bedingung stimmt
						Wend

				Else 
															'sollte v negativ sein, so ergibt der hexadezimale Wert etwas 
					sValHex = Right(sValHex,nhex)		'anderes als bei positiven Werten. (z.B. v = -880 -> FFFFFC90)
															'deshalb mssen die 4 Werte von rechts verwendet werden.	
				End If 
		If nhex = 4 Then									'alles wird zu einem Ganzen zusammengefgt.
				For i = 1 To nhex									
					sValue = sValue & "0" & Mid(sValHex, i, 1)	'nhex bestimmt dabei die Lnge der Zusammenstellung	
				Next i
		Else
			sValue = sValHex
		End If
			FillHex = sValue
End Function

Sub SendBytes(ByVal sSend As String)
	Dim sByte As String
	
	If Len(sSend) Mod 2 = 1 Then			'die Stringkette wird in Packete von jeweils zwei Zeichen zerlegt
		Print "len of SendBytes is not even! brake!"
		Exit Sub	
	End If
	
	While Len(sSend) > 0
		sByte = "&H" & Left(sSend,2)		'&H wird an die Packete vorne angehngt
		sSend = Right(sSend,Len(sSend)-2)			
		If sByte = "&H00" Then				'sollte ein NullByte vorkommen wird dieses direkt gesendet
			CommSend 0
		Else
			CommSend Chr(sByte)				'das Packet wird in Character umgewandelt um gesendet zu werden
		End If									
	Wend	
End Sub

Sub SendValue(dst As String, v As Variant, svrinfo As String)
	
	Print "sendValue dst: " & dst & " v: " & CStr(v) & " svrinfo: " & svrinfo
	
	Dim sSend As String	
	sSend = dst & MergeValue_SvrInfo(v, svrinfo)	'die komplette Zeichenkette wird zusammengestellt,bestehend aus
	SendBytes sSend									'dst(Adresse) & verarbeiteten svrinfo
End Sub

Sub OnReceive(ByteData As Byte)
	Dim dst As String
	Dim  v As String 
	Dim bCommand As Boolean

	g_A(g_AWI) = ByteData
	Print "OnReceive: " & ByteData
	Print "ByteDataIndex: " & g_AWI
	Print "ByteData: " & g_A(g_AWI)
	g_AWI = g_AWI + 1
	Print "Hexi: " & &H90  
	
	bCommand = True 
	While bCommand 
		If g_A(0) = &H90 Then
			Print "receive data xxx"
			If g_AWI > 5 Then		'e.g. the telegram starting with &H01 is 4 byte long (index 0 to 4)  
				
				'check the data an process them here
				FireReceiveValue dst, v 							'address and value to the server
				ShiftAccuLeft(5)
			Else
				bCommand = False
			End If
		Else
			'first byte of accu contents no head data - delete it!
			Print "delete"
			If g_AWI > 0 Then
				ShiftAccuLeft(1)
			Else
				bCommand = False				
			End If
		End If
	Wend
End Sub


Sub ShiftAccuLeft(ByVal nPos As Integer)		'a helpful little function if the accu is used - some bigger example show it a better way - call for them!
	Dim i As Integer
	For i = 0 To g_AWI - 1
		g_A(i) = g_A(i + nPos)
	Next i
	g_AWI = g_AWI - nPos
End Sub












